<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.5"/>
<title>fwXML: fwXML.ctl File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">fwXML
   &#160;<span id="projectnumber">8.4.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.5 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('fwXML_8ctl.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">fwXML.ctl File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="memitem:a77ab71766320898e661a78f25273af7a"><td class="memItemLeft" align="right" valign="top">private const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a77ab71766320898e661a78f25273af7a">fwXml_PARSING_DOWNORACROSS</a> = 0</td></tr>
<tr class="separator:a77ab71766320898e661a78f25273af7a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a94a22128098cfb58e5a42ff0da2cbcae"><td class="memItemLeft" align="right" valign="top">private const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a94a22128098cfb58e5a42ff0da2cbcae">fwXml_PARSING_WHEN_LEAVING</a> = 1</td></tr>
<tr class="separator:a94a22128098cfb58e5a42ff0da2cbcae"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3e2871253c100fc74c2fb29f00bd0f8"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#ae3e2871253c100fc74c2fb29f00bd0f8">fwXml_SAXSTARTELEMENT</a> = 2</td></tr>
<tr class="separator:ae3e2871253c100fc74c2fb29f00bd0f8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30a6db1f8cdacf8631dec1125b519c4e"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a30a6db1f8cdacf8631dec1125b519c4e">fwXml_SAXENDELEMENT</a> = 3</td></tr>
<tr class="separator:a30a6db1f8cdacf8631dec1125b519c4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae753e8fce103ca760beac9bba4c9874b"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#ae753e8fce103ca760beac9bba4c9874b">fwXml_SAXTEXT</a> = 6</td></tr>
<tr class="separator:ae753e8fce103ca760beac9bba4c9874b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a910d6a398bc228dbb0f2c48e38f8deca"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a910d6a398bc228dbb0f2c48e38f8deca">fwXml_CONTAINS_SIMPLE_ELEMENT_NODES</a> = 0</td></tr>
<tr class="separator:a910d6a398bc228dbb0f2c48e38f8deca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a72c8657ad884fed140b99eb990b3d7"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a7a72c8657ad884fed140b99eb990b3d7">fwXml_CONTAINS_TEXT_NODES</a> = 8</td></tr>
<tr class="separator:a7a72c8657ad884fed140b99eb990b3d7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8b6fbf9b366c7c6c9755e8e03567f77e"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a8b6fbf9b366c7c6c9755e8e03567f77e">fwXml_CONTAINS_COMMENT_NODES</a> = 256</td></tr>
<tr class="separator:a8b6fbf9b366c7c6c9755e8e03567f77e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d39ab83e8e814962f21e21efcd64388"><td class="memItemLeft" align="right" valign="top">const int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a2d39ab83e8e814962f21e21efcd64388">fwXml_CONTAINS_COMPLEX_ELEMENT_NODES</a> = 2</td></tr>
<tr class="separator:a2d39ab83e8e814962f21e21efcd64388"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad54d850e3967f98336994abb074c8a6e"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#ad54d850e3967f98336994abb074c8a6e">fwXml_CHILDNODESTYPE</a> = &quot;fwXml_ChildNodesType&quot;</td></tr>
<tr class="separator:ad54d850e3967f98336994abb074c8a6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6c0f8532906bf15cee1c353b753f3c0"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#af6c0f8532906bf15cee1c353b753f3c0">fwXml_CHILDSUBTREEID</a> = &quot;fwXml_ChildSubTreeId&quot;</td></tr>
<tr class="separator:af6c0f8532906bf15cee1c353b753f3c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8842054f455e7af91bff4ef4bef0449"><td class="memItemLeft" align="right" valign="top">private int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#ab8842054f455e7af91bff4ef4bef0449">_fwXml_getTypeOfCallback</a> (int parsingDownAcrossOrUp, int nodeType)</td></tr>
<tr class="separator:ab8842054f455e7af91bff4ef4bef0449"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb2bd212d8ae34e78bb9977d431b87c1"><td class="memItemLeft" align="right" valign="top">private void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#afb2bd212d8ae34e78bb9977d431b87c1">_fwXml_parseSaxRecursive</a> (int documentId, mapping callBackList, int level, int topNodeId, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:afb2bd212d8ae34e78bb9977d431b87c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2311b220a5170c01d2a0b96b38b18852"><td class="memItemLeft" align="right" valign="top">public int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a2311b220a5170c01d2a0b96b38b18852">fwXml_parseSaxFromFile</a> (string xmlDocumentName, mapping callBackList, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a2311b220a5170c01d2a0b96b38b18852"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afc3e1f4fd179e39d95efb908ea26a2da"><td class="memItemLeft" align="right" valign="top">private void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#afc3e1f4fd179e39d95efb908ea26a2da">_fwXml_getElementsRecursive</a> (unsigned documentId, int topNodeId, string tagName, dyn_int &amp;elements, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:afc3e1f4fd179e39d95efb908ea26a2da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad211ccc3f6e1654816e8acf451a363c6"><td class="memItemLeft" align="right" valign="top">public dyn_int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#ad211ccc3f6e1654816e8acf451a363c6">fwXml_elementsByTagName</a> (unsigned documentId, int topNodeId, string tagName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ad211ccc3f6e1654816e8acf451a363c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a243871968b0f19cf32bfaa2d19ca29b2"><td class="memItemLeft" align="right" valign="top">public bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a243871968b0f19cf32bfaa2d19ca29b2">fwXml_containsNodeTypes</a> (int setOfTypes, int requestedTypes)</td></tr>
<tr class="separator:a243871968b0f19cf32bfaa2d19ca29b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6be5b2d70359bb48146846329ee9c958"><td class="memItemLeft" align="right" valign="top">public int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a6be5b2d70359bb48146846329ee9c958">fwXml_childNodesContent</a> (unsigned documentId, int topNodeId, dyn_string &amp;node_names, dyn_anytype &amp;attributes, dyn_string &amp;nodevalues, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a6be5b2d70359bb48146846329ee9c958"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0612fae1db2861a3cf35521ad1592838"><td class="memItemLeft" align="right" valign="top">public int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="fwXML_8ctl.html#a0612fae1db2861a3cf35521ad1592838">fwXml_appendChildContent</a> (unsigned documentId, int topNodeId, dyn_string node_names, dyn_anytype attributes, dyn_string nodevalues, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:a0612fae1db2861a3cf35521ad1592838"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This library contains the XML SAX function call and some additional XML DOM function calls.</p>
<dl class="section user"><dt>Creation Date</dt><dd>01/12/2008</dd></dl>
<dl class="section user"><dt>Modification History</dt><dd>09/11/2015: Code Improvement as a result of Crucible 19/08/2013: Generalise fwXml_appendChildContent Bug in recovery mechanism of fwXml_appendChildContent 06/04/2010: Removed .dll extension from #uses 22/06/2009: Added fwXml_appendChildContent 01/12/2008: Initial version</dd></dl>
<dl class="section user"><dt>Constraints</dt><dd>For PVSS 3.6 SP2 and later versions</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="section author"><dt>Author</dt><dd>01/02/2016 - James Hamilton (EN-ICE) 01/12/2008 - Daniel Davids (IT-CO) </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="ab8842054f455e7af91bff4ef4bef0449"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private int _fwXml_getTypeOfCallback </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>parsingDownAcrossOrUp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>nodeType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'_fwXml_getTypeOfCallback' calculates the type of 'callback' that needs to be executed!
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Private</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">parsingDownAcrossOrUp</td><td>input, the parsing direction </td></tr>
    <tr><td class="paramname">nodeType</td><td>input, the node-type of the encopuntered node </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>output, the type of callback</dd></dl>
<dl class="section user"><dt>Philosophy</dt><dd>The philosophy behind this is that a non-leaf node can be parsed in two directions, when going down (pre-fix scanning) or when going up (post-fix scanning). A leaf node can only be parsed in one direction, across (infix scanning). </dd></dl>
<dl class="section user"><dt></dt><dd>To make an association between a note-type and the corresponding type of 'callback', one has made the following rule: the type of callback to be executed when parsing down or across is twice the node-type's value; the type of callback to be executed when parsing up is twice the node-type's value plus one! </dd></dl>

</div>
</div>
<a class="anchor" id="afb2bd212d8ae34e78bb9977d431b87c1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private void _fwXml_parseSaxRecursive </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>documentId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">mapping&#160;</td>
          <td class="paramname"><em>callBackList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>level</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>topNodeId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'_fwXml_parseSaxRecursive' called by 'fwXml_parseSaxFromFile' and itself in a recursive way.
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Private</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">documentId</td><td>input, the document-ident of the loaded Xml file </td></tr>
    <tr><td class="paramname">callBackList</td><td>input, the callback functions to be called while parsing </td></tr>
    <tr><td class="paramname">level</td><td>input, the current nesting-level of the recursive calls </td></tr>
    <tr><td class="paramname">topNodeId</td><td>input, the top node-ident from which the sub-tree is parsed </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>inout, returns details of any exceptions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void </dd></dl>

</div>
</div>
<a class="anchor" id="a2311b220a5170c01d2a0b96b38b18852"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">public int fwXml_parseSaxFromFile </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>xmlDocumentName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">mapping&#160;</td>
          <td class="paramname"><em>callBackList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'fwXml_parseSaxFromFile' parses an Xml-file according to the SAX mechanism with user-defined callbacks.
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">xmlDocumentName</td><td>input, the file-name of the Xml file to be parsed </td></tr>
    <tr><td class="paramname">callBackList</td><td>input, the callback functions to be called while parsing </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>inout, returns details of any exceptions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>output, 0 on success and -1 if an error during parsing occurred</dd></dl>
<dl class="section user"><dt>SAX Callback Mechanism</dt><dd>The callback function-names are passed to the 'fwXml_parseSaxFromFile' function as a PVSS mapping. Three different callbacks are currently implemented which can be activated by associating them to corresponding function-names in the PVSS mapping. The parameter passing of the callback functions follow very closely the Qt-implementation of the 'QXmlContentHandler'. These three types are the following: </dd></dl>
<dl class="section user"><dt></dt><dd>Type 'fwXml_StartElement' called when an Xml element-node is encountered.<br/>
 Activate: 'callBackList[fwXml_StartElement] = "&lt;start-element-callback&gt;";'<br/>
 Declaration: 'void &lt;start-element-callback&gt; ( string elementName , mapping elementAttributes )' </dd></dl>
<dl class="section user"><dt></dt><dd>Type 'fwXml_EndElement' called when an Xml element-node is left (exited).<br/>
 Activate: 'callBackList[fwXml_EndElement] = "&lt;end-element-callback&gt;";'<br/>
 Declaration: 'void &lt;end-element-callback&gt; ( string elementName )' </dd></dl>
<dl class="section user"><dt></dt><dd>Type 'fwXml_Characters' called when an Xml text-node is encountered.<br/>
 Activate: 'callBackList[fwXml_Characters] = "&lt;characters-callback&gt;";'<br/>
 Declaration: 'void &lt;characters-callback&gt; ( string characters )'</dd></dl>
<dl class="section user"><dt></dt><dd>A typical example is included in the example-panel "xmlParseSaxFromFileExample.pnl". The Xml-file "xmlExampleSaxParsing.xml" is parsed by the program in this panel. The push-button parses the Xml-file in a pre-order traversal of the element tree and calls the user-defined callbacks on encountering the various node-boundaries.</dd></dl>
<dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000001">Reviewed:</a></b></dt><dd>2018-07-25 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-FalsePositive">FalsePositive</a></dd></dl>

</div>
</div>
<a class="anchor" id="afc3e1f4fd179e39d95efb908ea26a2da"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private void _fwXml_getElementsRecursive </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>documentId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>topNodeId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>tagName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_int &amp;&#160;</td>
          <td class="paramname"><em>elements</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'_fwXml_getElementsRecursive' called by 'fwXml_elementsByTagName' and itself in a recursive way.
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Private</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">documentId</td><td>input, the document identifier </td></tr>
    <tr><td class="paramname">topNodeId</td><td>input, the top node-identifier of the parent or -1 (root-node) </td></tr>
    <tr><td class="paramname">tagName</td><td>input, the tag-name of the children which need to be returned </td></tr>
    <tr><td class="paramname">elements</td><td>inout, the elements satisfying the tag-name condition </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>inout, returns details of any exceptions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>void </dd></dl>

</div>
</div>
<a class="anchor" id="ad211ccc3f6e1654816e8acf451a363c6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">public dyn_int fwXml_elementsByTagName </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>documentId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>topNodeId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>tagName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'fwXml_elementsByTagName' returns all children which have a specific element's tag-name
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">documentId</td><td>input, the document identifier </td></tr>
    <tr><td class="paramname">topNodeId</td><td>input, the top node-identifier of the parent or -1 (root-node) </td></tr>
    <tr><td class="paramname">tagName</td><td>input, the tag-name of the children which need to be returned </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>inout, returns details of any exceptions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>output, all children which have a specific element's tag-name</dd></dl>
<dl class="section user"><dt></dt><dd>Returns a dynamic-integer array containing all descendent elements of this element that are called tag-name. The order they are in the dynamic-integer array is the order they are encountered in a pre-order traversal of the element tree. If '-1' is given to the node-identifier's value, then the whole document is searched.</dd></dl>
<dl class="section user"><dt></dt><dd>A typical example is included in the example-panel "xmlElementsByTagNameExample.pnl". The Xml-file "xmlExampleProcessTags.xml" is parsed by the two programs in this panel. The first push-button gets the element-nodes with tagnames 'home', 'room' and 'floor'. The second push-button gets only the element-nodes of the 'room's which are within 'bedrooms's.</dd></dl>
<dl class="section user"><dt>How to use...</dt><dd>Note that one needs to load the XML document first into memory and that one may only close the XML document once all manipulations have been finished on the XML nodes of the document.</dd></dl>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> xml_full_name, errMsg;</div>
<div class="line"><span class="keywordtype">int</span> rtn_code, docum, errLin, errCol;</div>
<div class="line">dyn_string exInfo;</div>
<div class="line">dyn_int elements;</div>
<div class="line"></div>
<div class="line">  docum = xmlDocumentFromFile ( xml_full_name , errMsg , errLin , errCol );</div>
<div class="line">  </div>
<div class="line">  <span class="keywordflow">if</span> ( docum &lt; 0 )</div>
<div class="line">  {</div>
<div class="line">    DebugN ( <span class="stringliteral">&quot;Parsing Error-Message = &#39;&quot;</span> + errMsg + <span class="stringliteral">&quot;&#39; Line=&quot;</span> + errLin + <span class="stringliteral">&quot; Column=&quot;</span> + errCol );</div>
<div class="line">  }</div>
<div class="line">  <span class="keywordflow">else</span></div>
<div class="line">  {</div>
<div class="line">    <span class="comment">// Manipulate here the XML nodes of the document</span></div>
<div class="line">  </div>
<div class="line">    elements = <a class="code" href="fwXML_8ctl.html#ad211ccc3f6e1654816e8acf451a363c6">fwXml_elementsByTagName</a> ( docum , ... , exInfo );</div>
<div class="line">    </div>
<div class="line">    rtn_code = xmlCloseDocument ( docum );</div>
<div class="line">    DebugN ( <span class="stringliteral">&quot;rtn_code = &quot;</span> + rtn_code );</div>
<div class="line">  }</div>
</div><!-- fragment --> 
</div>
</div>
<a class="anchor" id="a243871968b0f19cf32bfaa2d19ca29b2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">public bool fwXml_containsNodeTypes </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>setOfTypes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>requestedTypes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'fwXml_containsNodeTypes'
</pre><p> Checks if the returned contents node-types are all present in the set of requested ones.</p>
<dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">setOfTypes</td><td>input, contents node-types to be checked </td></tr>
    <tr><td class="paramname">requestedTypes</td><td>input, set of requested node-types that are allowed </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>output, boolean, returned contents node-types are all present in the set of requested ones</dd></dl>
<dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000002">Reviewed:</a></b></dt><dd>2018-07-25 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-FalsePositive">FalsePositive</a></dd></dl>

</div>
</div>
<a class="anchor" id="a6be5b2d70359bb48146846329ee9c958"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">public int fwXml_childNodesContent </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>documentId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>topNodeId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>node_names</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_anytype &amp;&#160;</td>
          <td class="paramname"><em>attributes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>nodevalues</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'fwXml_childNodesContent' returns tags, attributes and contained data of all children
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">documentId</td><td>input, the document identifier </td></tr>
    <tr><td class="paramname">topNodeId</td><td>input, the top node-identifier of the parent element-node container </td></tr>
    <tr><td class="paramname">node_names</td><td>output, the node-names or tag-names for element-nodes </td></tr>
    <tr><td class="paramname">attributes</td><td>output, the attributes of element-nodes and added infomation </td></tr>
    <tr><td class="paramname">nodevalues</td><td>output, the node-values or values of the unique child's text-node </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>inout, returns details of any exceptions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>output, the combined types of the type of children which data is returned</dd></dl>
<dl class="section user"><dt>When used for simple Xml-file structures</dt><dd>If the function returns 'fwXml_CONTAINS_SIMPLE_ELEMENT_NODES', then the child-nodes are all element-nodes which contain at most one text-node as their child. The following is returned via the three output-parameters: 'node_names' returns the tag-names of the element-nodes, 'attributes' returns all the attributes of the element-nodes, 'nodevalues' returns the value (character-data) of the contained text-node if present, otherwise it returns the empty string.</dd></dl>
<dl class="section user"><dt></dt><dd>A typical example is included in the example-panel "xmlChildNodesContentExample.pnl" (first push-button). The Xml-file "xmlExampleFlatListing.xml" can be completely read by issuing one single call to this function - specify for the 'node' variable the node-identifier of the element-node called "&lt;room&gt;".</dd></dl>
<dl class="section user"><dt></dt><dd>Note that this function was created especially for users who want to parse Xml-files of a structure which corresponds to the above description. Only read further if you want to use this function to parse more complex Xml-file structures.</dd></dl>
<dl class="section user"><dt>When used for complex Xml-file structures</dt><dd>If any of the child-nodes is different from an element-node which contains at most one text-node as its child, then the return-code will be different from 'fwXml_CONTAINS_SIMPLE_ELEMENT_NODES' [and will be more specific the bitwise OR-ed values which are obtained by shifting the value '1' to the left by a number of places which corresponds to the internal enumerated value of the node-type].</dd></dl>
<dl class="section user"><dt></dt><dd>An example will illustrate this much easier. Refer again to the example-panel "xmlChildNodesContentExample.pnl" (second push-button). The Xml-file corresponds this time to "xmlExampleGreatText.xml". In this example there is in addition to the above at least one text-node as a direct child (not as a child of an element-node). In that case, the return-code is 'fwXml_CONTAINS_TEXT_NODES' [this is obtained by shifting '1' to the left by XML_TEXT_NODE places (1&lt;&lt;XML_TEXT_NODE) [1&lt;&lt;3]].</dd></dl>
<dl class="section user"><dt></dt><dd>For nodes which are not element-nodes, the returned values are: 'node_names' returns the node-name of the node as queried by 'xmlNodeName', 'attributes' returns a single mapping "[fwXml_CHILDNODESTYPE;(int)&lt;node-type&gt;]" which indicates the node-type of the node, 'nodevalues' returns the node-value of the node as queried by 'xmlNodeValue'.</dd></dl>
<dl class="section user"><dt></dt><dd>If there is additionally at least one child-node with more than one child or with a child which is not a text-node then the return-code will have the bit-value '2' also set. The same example-panel "xmlChildNodesContentExample.pnl" illustrates this. Third button parses the "xmlExampleHierarchical.xml" Xml-file - return-code corresponds to 'fwXml_CONTAINS_COMPLEX_ELEMENT_NODES' [(1&lt;&lt;XML_ELEMENT_NODE) [1&lt;&lt;1]]. Fourth button parses the Xml-file "xmlExampleMoreComplex.xml" - return-code corresponds to 'fwXml_CONTAINS_COMPLEX_ELEMENT_NODES | fwXml_CONTAINS_TEXT_NODES' [obtained by bitwise OR-ing of (1&lt;&lt;XML_ELEMENT_NODE) and (1&lt;&lt;XML_TEXT_NODE) which is [(1&lt;&lt;1)|(1&lt;&lt;3)]].</dd></dl>
<dl class="section user"><dt></dt><dd>For element-nodes with more than one child or with a child which is not a text-node, the returned values are: 'node_names' returns the tag-name of the node, 'attributes' returns all the attributes of the element-nodes with additionally the two following added mappings "[fwXml_CHILDNODESTYPE;(int)XML_ELEMENT_NODE]" which is the node-type and "[fwXml_CHILDSUBTREEID;(int)&lt;element-node-identifier&gt;]", 'nodevalues' returns the empty string.</dd></dl>
<dl class="section user"><dt>How to use...</dt><dd>Note that one needs to load the XML document first into memory and that one may only close the XML document once all manipulations have been finished on the XML nodes of the document.</dd></dl>
<div class="fragment"><div class="line"><span class="keywordtype">string</span> xml_full_name, errMsg;</div>
<div class="line"><span class="keywordtype">int</span> rtn_code, docum, nodeIdentifier, errLin, errCol;</div>
<div class="line">dyn_string exInfo;</div>
<div class="line"></div>
<div class="line">  docum = xmlDocumentFromFile ( xml_full_name , errMsg , errLin , errCol );</div>
<div class="line">  </div>
<div class="line">  <span class="keywordflow">if</span> ( docum &lt; 0 )</div>
<div class="line">  {</div>
<div class="line">    DebugN ( <span class="stringliteral">&quot;Parsing Error-Message = &#39;&quot;</span> + errMsg + <span class="stringliteral">&quot;&#39; Line=&quot;</span> + errLin + <span class="stringliteral">&quot; Column=&quot;</span> + errCol );</div>
<div class="line">  }</div>
<div class="line">  <span class="keywordflow">else</span></div>
<div class="line">  {</div>
<div class="line">    <span class="comment">// Search first for the XML element node one is interested in...</span></div>
<div class="line">  </div>
<div class="line">    rtn_code = <a class="code" href="fwXML_8ctl.html#a6be5b2d70359bb48146846329ee9c958">fwXml_childNodesContent</a> ( docum , nodeIdentifier , ... , exInfo );</div>
<div class="line"></div>
<div class="line">    rtn_code = xmlCloseDocument ( docum );</div>
<div class="line">  }</div>
</div><!-- fragment --> 
</div>
</div>
<a class="anchor" id="a0612fae1db2861a3cf35521ad1592838"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">public int fwXml_appendChildContent </td>
          <td>(</td>
          <td class="paramtype">unsigned&#160;</td>
          <td class="paramname"><em>documentId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>topNodeId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>node_names</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_anytype&#160;</td>
          <td class="paramname"><em>attributes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>nodevalues</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">'fwXml_appendChildContent' appends element-nodes, attributes and contained data to the Xml Tree
</pre><dl class="section user"><dt>Constraints</dt><dd>None</dd></dl>
<dl class="section user"><dt>Usage</dt><dd>Public</dd></dl>
<dl class="section user"><dt>PVSS managers</dt><dd>UI, CTRL</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">documentId</td><td>input, the document identifier </td></tr>
    <tr><td class="paramname">topNodeId</td><td>input, the top node-identifier of the parent element-node container </td></tr>
    <tr><td class="paramname">node_names</td><td>input, tag-names for element-nodes </td></tr>
    <tr><td class="paramname">attributes</td><td>input, the attributes of element-nodes </td></tr>
    <tr><td class="paramname">nodevalues</td><td>input, the values of the unique child's text-node </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>inout, returns details of any exceptions </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>output, 0 on success and -1 if an error during construction occurred</dd></dl>
<dl class="section user"><dt>Used for simple and more complex Xml-file structures</dt><dd>This function constructs underneath the given node an ordered list of children element-nodes, or other types of nodes like: text-nodes, cdata-section nodes or comment nodes. Each of these children element-nodes gets their corresponding attributes and if defined and not the empty-string their corresponding child text-node.</dd></dl>
<dl class="section user"><dt></dt><dd>A typical example is included in the example-panel "xmlCreateChildContentExample.pnl". The first push-button creates a list of element-nodes. The second push-button creates a list of element-nodes with most of them having a unique child's text-node. The third push-button creates a list of element-nodes with some of them having one or more qualifying attributes. The fourth push-button combines all the above examples together and creates a list of element-nodes with some of them attributes and most of them a unique child's text-node. The fifth push-button shows you how to add more exotic elements like text-nodes, cdata-section nodes and comment nodes.</dd></dl>
<dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000003">Reviewed:</a></b></dt><dd>2018-07-25 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-FalsePositive">FalsePositive</a></dd></dl>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a class="anchor" id="a77ab71766320898e661a78f25273af7a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private const int fwXml_PARSING_DOWNORACROSS = 0</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_PARSING_DOWNORACROSS
</pre><p> Constant used in calculating the type of 'callback' that needs to be executed! This directive specifiy the 'callbacks' to be executed when parsing down or across for leave-nodes. </p>

</div>
</div>
<a class="anchor" id="a94a22128098cfb58e5a42ff0da2cbcae"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">private const int fwXml_PARSING_WHEN_LEAVING = 1</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_PARSING_DOWNORACROSS
</pre><p> Constant used in calculating the type of 'callback' that needs to be executed! This directive specifiy the 'callbacks' to be executed when parsing up, which means leaving the node. </p>

</div>
</div>
<a class="anchor" id="ae3e2871253c100fc74c2fb29f00bd0f8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_SAXSTARTELEMENT = 2</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_SAXSTARTELEMENT
</pre><p> Constant used in the mapping that associates the user-defined callback to the start of an Xml element-node </p>

</div>
</div>
<a class="anchor" id="a30a6db1f8cdacf8631dec1125b519c4e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_SAXENDELEMENT = 3</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_SAXENDELEMENT
</pre><p> Constant used in the mapping that associates the user-defined callback to the end of an Xml element-node </p>

</div>
</div>
<a class="anchor" id="ae753e8fce103ca760beac9bba4c9874b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_SAXTEXT = 6</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_SAXTEXT
</pre><p> Constant used in the mapping that associates the user-defined callback to an Xml text-node </p>

</div>
</div>
<a class="anchor" id="a910d6a398bc228dbb0f2c48e38f8deca"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_CONTAINS_SIMPLE_ELEMENT_NODES = 0</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_CONTAINS_SIMPLE_ELEMENT_NODES
</pre><p> The constants used to check the return-code of the 'fwXml_childNodesContent' function. One needs to OR those flags together and pass it as the 'requestedTypes' parameter in the call to 'fwXml_containsNodeTypes'. The return-value of the function 'fwXml_childNodesContent' is then passed as the 'setOfTypes' parameter in the same call to 'fwXml_containsNodeTypes'. </p>

</div>
</div>
<a class="anchor" id="a7a72c8657ad884fed140b99eb990b3d7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_CONTAINS_TEXT_NODES = 8</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_CONTAINS_TEXT_NODES
</pre><p> The constants used to check the return-code of the 'fwXml_childNodesContent' function. One needs to OR those flags together and pass it as the 'requestedTypes' parameter in the call to 'fwXml_containsNodeTypes'. The return-value of the function 'fwXml_childNodesContent' is then passed as the 'setOfTypes' parameter in the same call to 'fwXml_containsNodeTypes'. </p>

</div>
</div>
<a class="anchor" id="a8b6fbf9b366c7c6c9755e8e03567f77e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_CONTAINS_COMMENT_NODES = 256</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_CONTAINS_COMMENT_NODES
</pre><p> The constants used to check the return-code of the 'fwXml_childNodesContent' function. One needs to OR those flags together and pass it as the 'requestedTypes' parameter in the call to 'fwXml_containsNodeTypes'. The return-value of the function 'fwXml_childNodesContent' is then passed as the 'setOfTypes' parameter in the same call to 'fwXml_containsNodeTypes'. </p>

</div>
</div>
<a class="anchor" id="a2d39ab83e8e814962f21e21efcd64388"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const int fwXml_CONTAINS_COMPLEX_ELEMENT_NODES = 2</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_CONTAINS_COMPLEX_ELEMENT_NODES
</pre><p> The constants used to check the return-code of the 'fwXml_childNodesContent' function. One needs to OR those flags together and pass it as the 'requestedTypes' parameter in the call to 'fwXml_containsNodeTypes'. The return-value of the function 'fwXml_childNodesContent' is then passed as the 'setOfTypes' parameter in the same call to 'fwXml_containsNodeTypes'. </p>

</div>
</div>
<a class="anchor" id="ad54d850e3967f98336994abb074c8a6e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string fwXml_CHILDNODESTYPE = &quot;fwXml_ChildNodesType&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_CHILDNODESTYPE
</pre><p> Constant used in the mapping that identifies the node-type of the node in question </p>

</div>
</div>
<a class="anchor" id="af6c0f8532906bf15cee1c353b753f3c0"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const string fwXml_CHILDSUBTREEID = &quot;fwXml_ChildSubTreeId&quot;</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">fwXml_CHILDSUBTREEID
</pre><p> Constant used in the mapping that identifies the node-identifier of the node in question </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="fwXML_8ctl.html">fwXML.ctl</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.5 </li>
  </ul>
</div>
</body>
</html>
